
% Listings width
\def\ListingWidth{0.8\textwidth}
\algrenewcommand\algorithmicindent{1.0em}
\algrenewcommand{\algorithmicrequire}{\tiny \textbf{\tiny{Input:}}}
\algrenewcommand{\algorithmicensure}{\small{ \textbf{Output:}}}
\algrenewcommand{\alglinenumber}[1]{\color{red!80!blue}\footnotesize#1:}
\usepackage{calc} % for \widthof
\algrenewcommand\algorithmicfunction{\widthof{\textbf{\small{Function}}}}
\algrenewcommand{\algorithmiccomment}[1]{{\color{Green}\hfill\footnotesize $\vartriangleright$ #1}} %$\rhd$
\algnewcommand\algorithmicto{\textbf{to}}
 \algrenewtext{For}[3]%
   {\algorithmicfor\ $#1 \gets #2$ \algorithmicto\ $#3$ \algorithmicdo}
%\renewcommand{\algorithmiccomment}[1]{\hfill\eqparbox{COMMENT}{\# #1}}
\makeatletter
\renewcommand{\ALG@beginalgorithmic}{\small}

\let\OldStatex\Statex
\renewcommand{\Statex}[1][3]{%
  \setlength\@tempdima{\algorithmicindent}%
  \OldStatex\hskip\dimexpr#1\@tempdima\relax}
\newcommand{\StatexIndent}[1][3]{%
  \setlength\@tempdima{\algorithmicindent}%
  \Statex\hskip\dimexpr#1\@tempdima\relax}
\makeatother

  %\makebox[\widthof{\textbf{Function:}}][l]{\textbf{Function:}}}
%\algsetup{linenosize=\small}

%

\usepackage{datetime}

\makeatletter
\renewcommand*{\@fnsymbol}[1]{\ensuremath{\ifcase#1\or *\or
     \mathsection\or \mathparagraph\or \|\or **\or \dagger\dagger
     \or \ddagger\ddagger \else\@ctrerr\fi}}
\makeatother

\usepackage{hyperref,fancybox}
\makeatletter
     \@addtoreset{figure}{section}
     \@addtoreset{table}{section}
     \usepackage{marginnote}
     %\usepackage[top=1.5cm, bottom=1.5cm, outer=1cm, inner=2cm, heightrounded, marginparwidth=2.5cm, marginparsep=2cm]{geometry}
\makeatother

\newcolumntype{C}[1]{>{\centering\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}


\newif\ifstartedinmathmode
\newcommand{\FName}[1]{ {\footnotesize \color{DarkRed} \ifstartedinmathmode\mbox{\textsc{#1}}\else\textsc{#1}\fi }}
\newcommand{\FNameDef}[1]{\footnotesize {\color{red} \ifstartedinmathmode\mbox{\textsc{#1}}\else\textsc{#1}\fi }}
\newcommand{\FNameStd}[1]{\footnotesize {\color{blue} \ifstartedinmathmode\mbox{\textsc{#1}}\else\textsc{#1}\fi }}
\newcommand{\raisedrule}[2][0em]{\leaders\hbox{\rule[#1]{1pt}{#2}}\hfill}
\newcommand{\SeeAlso}[2]{
\begin{minipage}{#1}
\footnotesize{\color{violet}{
\textbf{\textit{See also :}} #2
}}
\end{minipage}}

\newcommand{\Input}[2]{
\begin{minipage}{#1}
\footnotesize \textbf{Input :}\\
#2 \\
\end{minipage}\\
}
\newcommand{\Output}[2]{
\begin{minipage}{#1}
\footnotesize \textbf{Output :}\\
#2 
\end{minipage}\\
}
%=======================================================================================================


\def\ElemMatD{LocalMatrix\_D}
\def\ElemMatguv{LocalMatrix\_guv}
\def\ElemMatgdudv{LocalMatrix\_gdudv}
\def\ElemMatgduv{LocalMatrix\_gduv}
\def\ElemMatgudv{LocalMatrix\_gudv}
\def\DAssemblybase{DAssemblyP1\_base}
\def\DAssemblyOptV0{DAssemblyP1\_OptV0}
\def\HAssemblybase{HAssemblyP1\_base}

\def\Gradients{Gradients}
\def\GradientsVec{gradientVec}
\def\getLocalDh{getLocalDh}
\def\getLocalData{getLocalData}

\def\ElemMatH{LocalMatrix\_H}
\def\ElemMatHOptV0{LocalMatrix\_HOptV0}

\def\Ddata{\Dhoperator}
\def\InitDoperator{InitDoperator}
\def\getLocalfData{getLocalfData}
\def\InitDdata{InitDdata}
\def\InitfData{setFdata}
\def\NeumannBC{NeumannBC}
\def\RobinBC{RobinBC}
\def\DirichletBC{DirichletBC}
\def\SndMember{RHS}
\def\setBCLabel{setBC\_PDE}

\def\SolveScalarPDE{SolveScalarPDE}
\def\SolveVectorPDE{SolveVectorPDE}
\def\SolvePDE{SolvePDE}

\def\GetMesh{GetMesh}

\newcommand{\varName}[1]{\texttt{#1}}
\def\DopStruct{{\rm D}}
\def\DdataStruct{{\rm D}_h}
\newcommand{\StructVar}[1]{{\rm #1}}
\newcommand{\StructField}[1]{{\rm #1}}
\newcommand{\DopField}[1]{\DopStruct.\StructField{#1}}
\newcommand{\StructAndField}[2]{\StructVar{#1}.\StructField{#2}}

\def\BC{\mathcal{BC}} % Boundary Condition
